.docker_login: &docker-login
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY} # registry.gitlab.com AND GITLAB predifined variables

.docker_push: &docker-push 
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} #registry.gitlab.com/just-cicd/only-app
    - if [[ $CI_COMMIT_REF_SLUG == "main"]]; then
         docker tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} ${CI_REGISTRY_IMAGE}:latest; fi
    - if [[ $CI_COMMIT_REF_SLUG == "main"]]; then
         docker push ${CI_REGISTRY_IMAGE}:latest; fi

.docker_build_dind: &docker-build-dind
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} . # registry.gitlab.com/just-cicd/only-app .

.docker_build:
  stage: build
  image: docker:stable
  variables:
    DOCKER_HOST: tcp://docker:2375 #(look "for gitlab ci dind exapmle"  and look for additional variables)
    DOCKER_TLS_CERTDIR: ""
  services:
    - docker:dind
  script:
    - *docker-login
    - *docker-build-dind
    - *docker-push
  tags:
    - docker


#.docker_release:
#  stage: build DELETE
#  image: docker:stable
#  variables:
#    DOCKER_HOST: tcp://docker:2375 #(look "for gitlab ci dind exapmle"  and look for additional variables)
#    DOCKER_TLS_CERTDIR: ""
#    IMAGE_BRANCH: "dev"
#  services:
#    - docker:dind
#  script:
#    - *docker-login
#    - docker pull ${CI_REGISTRY_IMAGE}:${IMAGE_BRANCH}
#    - docker tag ${CI_REGISTRY_IMAGE}:dev ${CI_REGISTRY_IMAGE}:latest  
#    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} 
#  tags:
#    - docker